#!/bin/bash
set -e

err() {
  printf "\033[0;31m%s\n\033[0m" "$*" >&2;
}
step () {
  python3 -c "text='$2'; desc=' {}'.format(text) if text else ''; print('\033[0;33;49m{}\033[0m ({:02}{}) \033[0;33;49m{}\033[0m'.format('-' * 8, $1, desc, '-' * (80 - len(desc))))"
}

# (1) install conan as python package in a virtual environment
step 1 "install conan from PyPI"
python3 -m venv venv
source ./venv/bin/activate
./venv/bin/pip3 install conan --upgrade

# (2) install cmake
step 2 "install cmake via apt"
#if [ "$EUID" -ne 0 ]; then
#  err "Please run as root"
#  exit
#fi
echo "Running 'apt install cmake'"
sudo apt install cmake

# (3) inform user about todo flags
step 3 "inform user"
echo "warning: there are several TODO flags in the codebase"
grep --color=always --directories=skip --exclude="$BASH_SOURCE" -n TODO ./*

echo "Done"
